%Problem 3.1
%---------------------------------------------------------------

%This is just the *index* of the nonlinearity for the function
%nlsystems1() (see it's help file!).
nl_id = 0;

%Choice of input signal: In system identification, you just have input and 
%output to identify a system. As the output is a function of the input, the latter
%will have a crucial influence on the identification. Do you expect a narrowband signal to 
%be able to identify a system entirely? Or might a broadband signal be more suitable?
n = (0:1023)';
xa = (n-512)';
xb = sin(pi/2*n)';
xc = randn(length(n),1);

%Let's take xc for example and calculate it's output
x = xc;
y = nlsystem1(x, nl_id);

%For vkernels.m (again: see help or presentation) you have to choose the order and
%memory depth of your approximation. One possibility: You have the NLs given, so you
%could just select the perfect parameters. This way you can find the best input signal.
%Then, you can play with the parameters and have a look what happens if you choose the 
%wrong ones on purpose.
P = 2;    %NL order
M = 3;    %Memory length

%First return parameter is a cell array (H{1} is the constant part, H{2} is the linear part, ...)
%second one is a data structure that you can directly pass to vkernels_o (see help)
[H, Vmodel] = vkernels(x, y, P, M);

%Finally, check the estimated approximization and try to compare them with the true ones.
H{1}
H{2}
H{3}




